#include <stdio.h>
#include <math.h>

typedef struct {
    double A;
    double B;
    int C;
} koosp;

typedef struct {
    double S;
    koosp nurgake;	
} kolm;

#define nimep 32
#define M_PI 3.14159265358979323846

/*
A)  Create an algorithm program, by means of which:
1. From the text file F1, records are entered with the structure:
     A, B  two real side lengths of the triangle,
      C is integer angle (in degrees) between them;
     2. Find area of a triangl and written it to the text file FF2
	  (and also displayed on the screen)
     * records with structure:
     double A,B, int C  entered values,
     double  S  area of the triangle;
         (each record is issued in one row).
*/

void loenim(char *, char[]);
int kontroll(FILE *);
int loemeA(FILE *);
void loemeF(kolm[], FILE *, int);
double arvutaPindala(koosp);
void tulemus(FILE *, kolm[], int);

int main(void) {
    int K, mitu;
	FILE *F1;
	char Fnum1[nimep];
	loenim("input file name ", Fnum1);
	F1 = fopen(Fnum1, "r");
	K = kontroll(F1);
	if (K) {
		printf("fail not found");
		return 1;
	}
	mitu = loemeA(F1);
	printf("%d\n", mitu);
	kolm kolmnur[mitu];
	loemeF(kolmnur, F1, mitu);
	fclose(F1);
	
	FILE *FF2 = fopen("FF2.txt", "w");
	if (FF2 == NULL) {
		printf("error! FF2.txt");
		return 1;
	}
	tulemus(FF2, kolmnur, mitu);
	fclose(FF2);
	
	return 0;
}

void loenim(char *text, char filename[]) {
	printf("%s", text);
	scanf("%s", filename);
}

int kontroll(FILE *inputfile) {
	if (inputfile == NULL)
		return 1;
	return 0;
}

int loemeA(FILE *inputfile) { 
	int record_count = 0;
	char buffer[100];
	while (fgets(buffer, sizeof(buffer), inputfile) != NULL) {
		record_count++;
	}
	rewind(inputfile);
	return record_count;
}

void loemeF(kolm kolmnurgad[], FILE *inputfile, int size) {
	int i = 0;
	while (fscanf(inputfile, "%lf %lf %d",
		&kolmnurgad[i].nurgake.A,
		&kolmnurgad[i].nurgake.B,
		&kolmnurgad[i].nurgake.C) != EOF) {
		i++;
	}
}

double arvutaPindala(koosp nurgad) {
    double a = nurgad.A;
    double b = nurgad.B;
    double c = nurgad.C * M_PI / 180.0; // radians
    return 0.5 * a * b * sin(c);
}

void tulemus(FILE *inputfile ,kolm kolmnurgad[], int size) {
    FILE *FF2 = fopen("FF2.txt", "w");
    if (FF2 == NULL) {
        printf("error FF2.txt");
        return;
    }
    
    for (int i = 0; i < size; i++) {
        double S = arvutaPindala(kolmnurgad[i].nurgake);
        fprintf(FF2, "%.2lf %.2lf %d %.2lf\n", kolmnurgad[i].nurgake.A, kolmnurgad[i].nurgake.B, kolmnurgad[i].nurgake.C, S);
        printf("nurk a: %.2lf nurk b :%.2lf %d pindala: %.2lf\n", kolmnurgad[i].nurgake.A, kolmnurgad[i].nurgake.B, kolmnurgad[i].nurgake.C, S);
    }
    fclose(FF2);
}
